︠416ceb18-9533-4b28-a2ff-6038aae0d3e3i︠
%html
<p>Hi there!<br /><br />I am engineer dealing with nonlinear dynamical systems. I made a spkg for Assimulo so that I can reach the Sundials solvers, particularly IDA (see thread on sage-devel).<br /><br />I am doing&nbsp; models which depend on the modal-shapes of a structure to describe it's motion.<br /><br />The model is built symbolically, and the size of the problem grows according to the number of modes used.<br /><br />Everything is working fine, but too slow. I am looking for ways to speedup the evaluation/substitution on symbolic matrices and vectors.<br /><br />It seems that fast_float and fast_callable is not available for these cases. In my opinion, this case Fortran seems much simpler than Cython.﻿<br /><br />My first idea was to translate the symbolic system of equation into Fortran and attach them back via f2py. The idea is to build a translator to compile symbolic entities which are to be evaluated numerically (intensively).<br /><br />Here I made a simple comparison and illustration of a use case.<br /><br />In this case simple case you see an improvement of at least 3 orders of magnitude.<br /><br />Just to mention that Maxima has a f90 translator, but it is very limited. It pretty much does a print() to a file.<br /><br />How can I build such a translator?<br /><br />- The solver expects numpy.array at the input and output of user defined residual and jacobian functions.<br /><br />- Floats must me decorated by the Fortran precision<br /><br />- Nice if we can pass arrays of parameters instead of long lists of dummy variables<br /><br />- Observe the 0-based Python to 1-based Fortran.<br /><br />- Observe the 1**2 instead of 1^2.<br />﻿</p>
<p>&nbsp;</p>

︡b35d1322-4c8a-48a3-9fc1-791bbc21c95b︡{"html": "<p>Hi there!<br /><br />I am engineer dealing with nonlinear dynamical systems. I made a spkg for Assimulo so that I can reach the Sundials solvers, particularly IDA (see thread on sage-devel).<br /><br />I am doing&nbsp; models which depend on the modal-shapes of a structure to describe it's motion.<br /><br />The model is built symbolically, and the size of the problem grows according to the number of modes used.<br /><br />Everything is working fine, but too slow. I am looking for ways to speedup the evaluation/substitution on symbolic matrices and vectors.<br /><br />It seems that fast_float and fast_callable is not available for these cases. In my opinion, this case Fortran seems much simpler than Cython.\ufeff<br /><br />My first idea was to translate the symbolic system of equation into Fortran and attach them back via f2py. The idea is to build a translator to compile symbolic entities which are to be evaluated numerically (intensively).<br /><br />Here I made a simple comparison and illustration of a use case.<br /><br />In this case simple case you see an improvement of at least 3 orders of magnitude.<br /><br />Just to mention that Maxima has a f90 translator, but it is very limited. It pretty much does a print() to a file.<br /><br />How can I build such a translator?<br /><br />- The solver expects numpy.array at the input and output of user defined residual and jacobian functions.<br /><br />- Floats must me decorated by the Fortran precision<br /><br />- Nice if we can pass arrays of parameters instead of long lists of dummy variables<br /><br />- Observe the 0-based Python to 1-based Fortran.<br /><br />- Observe the 1**2 instead of 1^2.<br />\ufeff</p>\n<p>&nbsp;</p>"}︡
︠dce04ca3-5449-41ac-a7a8-4cca0d43ff27︠
# bring the system into state-space representation 

M = 2   # number of modes

# position and derivative
u =vector(SR, list(var('y_%d' %i) for i in range(M)) )
ud=vector(SR, list(var('yd_%d' %i) for i in range(M)) )

# velocity and derivative
v =vector(SR, list(var('y_%d' %i) for i in range(M,2*M)) )
vd=vector(SR, list(var('yd_%d' %i) for i in range(M,2*M)) )

# dummy state dependent polynomials (in reality depend on M)
p = u[0]^2+u[0]+1
q = u[1]^2+u[1]+1

# dummy state dependent mass matrix (also depend on M)
m = matrix(SR,M)
m[:,:] = [[0.25*p*q, 0.125*p*q],[0.125*p*q, 0.15*p*q]]
︡325de0bc-8e8b-4152-9451-47fb67fb4ef8︡︡
︠8c9410c5-b364-41d8-bce0-e804d41ce737︠
# system of equations (kind-of harmonic oscillator)
# 0 = udot - v
# 0 = M*vdot + c*v + k*u - f(t)

eq1 = ud - v 
eq2 = m * vd  # further terms...
︡b79a1793-765b-46d8-83b9-e760b194bb31︡︡
︠b5dd6ea0-62bf-42c3-96d2-f7c49dde9ab8︠
# system as a vector
system = vector(SR,2*M)
system[0:M]= eq1
system[M: ]= eq2
︡3edcf077-06c0-463f-8647-62f53e0a1a95︡︡
︠df3e412a-97b9-46e6-8a9d-6124cb629451︠
# variables used on substitution
var1 = list(var('y_%d' %i)  for i in range(2*M))
var2 = list(var('yd_%d' %i) for i in range(2*M))
︡b977060b-8718-4b1b-9dd6-0a5e41c5169e︡︡
︠60f305d6-52c4-460c-8a4e-42d35d964ca1︠
# Residual function needed by the solver (another is needed for Jacobian)
# need numpy.array as input and return

import numpy as NP

def residual(t,y,yd):    
    res=NP.zeros(2*M)
    
    yn =dict(zip(var1,y[:2*M]))
    ydn=dict(zip(var2,yd[:2*M]))
    
    state = dict(yn.items() + ydn.items())
    
    # evaluate system at current solver time-step and state
    res[:]=system.substitute(state)
    
    return NP.array(res,float)
︡f674aa91-0829-47be-b0fb-e8031988e236︡︡
︠819f0e90-e8ec-48d5-bc18-bb518c319437︠
class ff_vector:
    def __init__(self, vec, *args, **kwds):
        self.comp = []
        self.nice = []
        kwds.setdefault('domain',float)
        
        for expr in vec:
            self.nice.append(expr)
            self.comp.append(fast_callable(expr, *args, **kwds))
    
    def __call__(self,*args):
        if len(args)==1:
            args = list(args[0])
        #v = vector(RDF, [f(*args) for f in self.comp])
        v = [f(*args) for f in self.comp]
        return v
        
    def __repr__(self):
        return 'ff_vector: '+repr(self.nice)
︡cd7da701-14f9-4a79-ac5f-b55d859b3899︡︡
︠0e5c0561-2881-41b2-bc37-3af4a39c825c︠
# Residual function needed by the solver (another is needed for Jacobian)
# need numpy.array as input and return

import numpy as NP
var1str=[str(v) for v in var1]
var2str=[str(v) for v in var2]
system_vec = ff_vector(system,vars=var1str+var2str)
print "vars",var1str+var2str

def residual_ff_vector(t,state):
    
    #state=list(y[:2*M])
    #state.extend(yd[:2*M])
    
    # evaluate system at current solver time-step and state
    return system_vec(*state)
︡af4e5161-33bd-40e9-8788-df84da6fa444︡{"stdout": "vars ['y_0', 'y_1', 'y_2', 'y_3', 'yd_0', 'yd_1', 'yd_2', 'yd_3']"}︡
︠36d40e6f-abb8-4b16-94d1-ab71fd7ab615︠
# simple test

t=0.0
y=NP.ones(2*M)
yd=NP.ones(2*M)
print t,y,yd
a = residual(t,y,yd); a
︡adbb2924-3dc5-493b-8cdf-488c30019fb0︡{"stdout": "0.000000000000000 [ 1.  1.  1.  1.] [ 1.  1.  1.  1.]\narray([ 0.   ,  0.   ,  3.375,  2.475])"}︡
︠1dd2c6b9-cd78-4cfc-91aa-761432e64185︠
type(a)
︡ca16bd40-8017-4595-9db6-8402209eca6f︡{"stdout": "<type 'numpy.ndarray'>"}︡
︠93f61616-c920-4491-8bbb-2ffea1c85e0e︠
a=residual_ff_vector(t,list(y[:2*M])+list(yd[:2*M])); a
︡d2b7bf26-3c64-45a1-b29b-b9c24dfb44b4︡{"stdout": "[0.0, 0.0, 3.375, 2.4749999999999996]"}︡
︠a3788b3e-80cf-452d-9659-6a75ed4b7911︠
print(system)
︡b0f5d203-c7a9-4e56-a323-83d467376373︡{"stdout": "(-y_2 + yd_0, -y_3 + yd_1, (y_1^2 + y_1 + 1)*(0.125000000000000*y_0^2 + 0.125000000000000*y_0 + 0.125000000000000)*yd_3 + (y_1^2 + y_1 + 1)*(0.250000000000000*y_0^2 + 0.250000000000000*y_0 + 0.250000000000000)*yd_2, (y_1^2 + y_1 + 1)*(0.125000000000000*y_0^2 + 0.125000000000000*y_0 + 0.125000000000000)*yd_2 + (y_1^2 + y_1 + 1)*(0.150000000000000*y_0^2 + 0.150000000000000*y_0 + 0.150000000000000)*yd_3)"}︡
︠f8d7f411-0348-4f02-a7c2-3308ccc7fea4i︠
%html
<p><span style="font-size: x-large;"><span style="background-color: #ffff99;">I would like to do:</span> </span></p>
<p><span style="font-size: x-large;">- Automate the translation of the sybolic system to a f2py equivalent.</span></p>

︡6389480d-5aff-4b00-ae28-e743253d0295︡{"html": "<p><span style=\"font-size: x-large;\"><span style=\"background-color: #ffff99;\">I would like to do:</span> </span></p>\n<p><span style=\"font-size: x-large;\">- Automate the translation of the sybolic system to a f2py equivalent.</span></p>"}︡
︠2b397fc2-0ee9-4785-b609-9356345f4eaa︠
%fortran
!f90
subroutine residual_fortran(t, y, yd, res, siz )
implicit none

integer, parameter :: DP = kind(1.0d0)

real (DP) :: t
real (DP) :: y(siz)          
real (DP) :: yd(siz)
real (DP) :: res(siz)
integer :: siz

intent (in)  :: t, y, yd, siz
intent (out) :: res

! # Pragmas f2py-specific
!f2py intent (in)  t, y, yd, siz
!f2py intent (out) res

res(1) = yd(1)- y(3)

res(2) = yd(2)- y(4)

res(3) = (y(2)**2 + y(2) + 1)*(0.125_DP*y(1)**2 + 0.125_DP*y(1) + &
& 0.125_DP)*yd(4) + (y(2)**2 + y(2) + 1)*(0.25_DP*y(1)**2 +       &
& 0.25_DP*y(1) + 0.25_DP)*yd(3)

res(4) = (y(2)**2 + y(2) + 1)*(0.125_DP*y(1)**2 + 0.125_DP*y(1) + &
& 0.125_DP)*yd(3) + (y(2)**2 + y(2) + 1)*(0.15_DP*y(1)**2 +       &
& 0.15_DP*y(1) + 0.15_DP)*yd(4)

end subroutine
︡48090b28-0e4e-49b1-b0e1-5ca0eb3525f1︡{"stdout": "None"}︡
︠739aef59-4492-4207-92e5-d2af97668b6d︠
print residual_fortran.__doc__
︡eb30328e-2714-4655-970e-2fa6171d9e99︡{"stdout": "residual_fortran - Function signature:\n  res = residual_fortran(t,y,yd,[siz])\nRequired arguments:\n  t : input float\n  y : input rank-1 array('d') with bounds (siz)\n  yd : input rank-1 array('d') with bounds (siz)\nOptional arguments:\n  siz := len(y) input int\nReturn objects:\n  res : rank-1 array('d') with bounds (siz)"}︡
︠56ec2c0a-5778-4a8a-babe-47ca2830a720︠
b= residual_fortran(t,y,yd); b
︡7ba80f95-fcfd-4fae-9799-cfd69ac7c2c1︡{"stdout": "array([ 0.   ,  0.   ,  3.375,  2.475])"}︡
︠9eb21e8e-e4b2-40ec-b65e-9962e296d981︠
type(b)
︡cea47547-c7d3-43f6-a257-2b79454b43e7︡{"stdout": "<type 'numpy.ndarray'>"}︡
︠b56a08ea-26d0-498a-a2d4-44c63a3164c9i︠
%html
<p><span style="font-size: x-large; background-color: #ffffff;">Comparing the implementations:</span></p>

︡228a68d1-f754-4d8b-becc-a85afc111128︡{"html": "<p><span style=\"font-size: x-large; background-color: #ffffff;\">Comparing the implementations:</span></p>"}︡
︠b9661aff-3711-4d78-8a66-97474c99321c︠
state=list(y[:2*M])+list(yd[:2*M])
︡7e621dde-d03d-4661-92d7-2f6aa6f2659f︡︡
︠ce17647a-63c0-4e36-8aba-9bac9794cab2︠
timeit('a=residual(t,y,yd)')
︡954a067d-66c4-488e-9858-242af97f312b︡{"stdout": "625 loops, best of 3: 875 \u00b5s per loop"}︡
︠fa33c785-924b-4d5d-b69d-a54bba8aaddb︠
timeit('a=residual_fortran(t,y,yd)')
︡f3decffa-e178-42bf-94c6-f99c4fc2c805︡{"stdout": "625 loops, best of 3: 688 ns per loop"}︡
︠bba7ad42-8465-48a2-b425-0c937561878f︠
timeit('a=residual_ff_vector(t,state)')
︡4d729bdf-f95c-4f14-aa4e-ea9f18634651︡{"stdout": "625 loops, best of 3: 3.56 \u00b5s per loop"}︡
